/* #############################################################################
Descriptives table Appendix:
############################################################################# */


/*
Note: Producing results for the Descriptives table in the Appendix.
*/

* Preliminaries
clear


* Directories *
cd "${local_workdir}"


* Log File
log using "${out_dir}/UK_DiD_AppTableDescriptives.log", replace

* Load saved dataset
use "${local_workdir}/UK_cleaned_data.dta", clear


* Time Sample
keep if year>=2019 //our regression  sample, 2019Q1 - 2020Q3

* Additional sample restrictions
drop if work_type==. // keep regression samples consistent across specifications
drop if child_grp==.
drop if broad_emp == .


* Variables for Table C
gen female     = sex==2
gen single_mom = sex==2 & (cohab == 0 & married == 0) & child_grp>=1
gen preK_kid   = child_grp==1
gen sch_kid    = child_grp==2
gen nonwhite   = simp_race

gen sample_size = _N

* Population Characteristics
#delim ;
collapse broad_emp raw_hours_lwk telecom female married single_mom 
		 preK_kid sch_kid simp_race college sample_size  [pw=PWT18];
#delim cr

* Save Results
export excel using "${out_dir}/UK_appendix_Table_C.xlsx",  sheet("pop characteristics",replace) first(var) sheetmodify

log close

